<?php

namespace Chemical\Service\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class ServiceTransformer extends TransformerAbstract
{
    public function transform(\Chemical\Service\Models\Service $service)
    {
        return [
            'id'                => $service->getRouteKey(),
            'key'               => [
                'public'    => $service->getPublicKey(),
                'route'     => $service->getRouteKey(),
            ], 
            'id'                => $service->id,
            'slug'              => $service->slug,
            'name'              => $service->name,
            'status'            => $service->status,
            'details'           => $service->details,
            'created_at'        => $service->created_at,
            'updated_at'        => $service->updated_at,
            'deleted_at'        => $service->deleted_at,
            'url'               => [
                'public'    => trans_url('service/'.$service->getPublicKey()),
                'user'      => guard_url('service/service/'.$service->getRouteKey()),
            ], 
            'status'            => trans('app.'.$service->status),
            'created_at'        => format_date($service->created_at),
            'updated_at'        => format_date($service->updated_at),
        ];
    }
}